; #########################################################################
;	-------------------------------------------
;	UnACEv2 example for MASM32v6 
;	Version: v0.52
;	Date created: 2001-10-09
;	Time spent: 12 complete days
;	Author: Florian Muecke (dev[AT]mueckeimnetz.de)
;	-------------------------------------------
;	Any comments, bugs, suggestions, problems ?
;	Feel free to write back.
;	-------------------------------------------
;   known problems:
;	- not programmed very well - but it works
;
; #########################################################################

    .486
    .model flat, stdcall
    option casemap :none		;case sensitive

; #########################################################################

	include \masm32\include\windows.inc
    include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\comctl32.inc 
	include .\include\strucs.inc
	include .\include\callback.inc
	include .\include\unacefnc.inc

	  
	includelib \masm32\lib\comctl32.lib 
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib .\include\UnACEv2.lib

; #########################################################################

	WndProc						PROTO :DWORD,:DWORD,:DWORD,:DWORD
	HandleStateStartArchive		PROTO Archive_:pACECallbackArchiveStruc
	HandleStateStartFile		PROTO ArchivedFile:pACECallbackArchivedFileStruc
	HandleErrorGlobal			PROTO Error:pACECallbackGlobalStruc
	HandleErrorArchive			PROTO Error:pACECallbackArchiveStruc
	HandleErrorArchivedFile		PROTO Error:pACECallbackArchivedFileStruc
	HandleErrorRealFile			PROTO Error:pACECallbackRealFileStruc
	HandleErrorSpace			PROTO Error:pACECallbackSpaceStruc
	HandleErrorSFXFile			PROTO Error:pACECallbackSFXFileStruc
	HandleRequestGlobal			PROTO Request:pACECallbackGlobalStruc
	HandleRequestArchive		PROTO Request:pACECallbackArchiveStruc
	HandleRequestArchivedFile	PROTO Request:pACECallbackArchivedFileStruc
	HandleRequestRealFile		PROTO Request:pACECallbackRealFileStruc
	InfoProc					PROTO Info:pACEInfoCallbackProcStruc
	ErrorProc					PROTO Error:pACEErrorCallbackProcStruc
	RequestProc					PROTO Request:pACERequestCallbackProcStruc
	StateProc					PROTO State:pACEStateCallbackProcStruc
	UserPrompt					PROTO PromptStr:LPSTR, Param:LPSTR, IsRequest:BOOL
	CallAceInitDll				PROTO
	FileExists					PROTO FileName:LPSTR
	CallACEList					PROTO ArchiveName:LPSTR
	CallACETest					PROTO ArchiveName:LPSTR
	CallACEExtract				PROTO ArchiveName:LPSTR, DestinationDir:LPSTR, DoExcludePath:BOOL

; #########################################################################

	FILELISTSIZE	EQU	32768	
	COMMENTBUFSIZE	EQU	8192	; comments may be up to 32k in size
								; increase it if you want to put that
								; large comments to archives, or if
								; you want to receive all of these large
								; comments (ACE_COMMENT_SMALLBUF returned
								; if comment does not fit into buffer)

; #########################################################################

.DATA

	hInstance		DD 0
	hIcon			DD 0
	hWindow			DD 0
	Result_			DD 0
	Dummy32_1		DD 0
	Dummy32_2		DD 0
	Dummy64_1		DQ 0
	Dummy64_2		DQ 0
	Dummy64_3		DQ 0
	Dummy64_4		DQ 0

	ArchiveData		tACEReadArchiveDataStruc <>
	DllData			tACEInitDllStruc <>

	ArchiveName_	DB "*.ace",260 dup (0)
	DestinationDir_ DB ".\test",254 dup (0)
	TempPath		DB 256 DUP (0)
	TextBuf			DB 256 dup (0)
	FileList		DB FILELISTSIZE DUP (0)		;32768
	CommentBuf		DB COMMENTBUFSIZE DUP (0)	;8192
	
	NStr			DB 0,0
	caption			DB "UnACEv2 Example",0


	ErrorMsg0		DB "Something went wrong !",0
	ErrorMsg1		DB "This is not an ACE-archive !",0
	ErrorMsg2		DB "No .ACE archive file found !",0

	ErrorStr0		DB "Error: ",0
	ErrorStr1		DB "not enough memory",0
	ErrorStr2		DB "could not detect available space on network drive",0
	ErrorStr3		DB "unknown ",0
	ErrorStr4		DB "invalid AV in archive: ",0
	ErrorStr5		DB "could not open archive: ",0
	ErrorStr6		DB "error reading from archive: ",0
	ErrorStr7		DB "broken archive: ",0
	ErrorStr8		DB "no files specified",0
	ErrorStr9		DB "file is not an ACE archive: ",0
	ErrorStr10		DB "this Dll version is not able to handle the archive: ",0
	ErrorStr11		DB "name is used by directory - could not extract: ",0
	ErrorStr12		DB "error writing ",0
	ErrorStr13		DB "error opening file for writing: ",0
	ErrorStr14		DB "compression method not known to this Dll version",0
	ErrorStr15		DB "not enough space to extract ",0
	ErrorStr16		DB "unable to create file (write-protection?): ",0

	InfoStr1		DB "creating file list",0
	InfoStr2		DB "finished creating file list",0
	InfoStr3		DB "adding file to file list",0

	ActionStr1		DB "Listing ",0
	ActionStr2		DB "Testing ",0
	ActionStr3		DB "Extracting ",0
	ActionStr4		DB "unknown operation on ",0
	ActionStr5		DB "Found",0
	ActionStr6		DB "Analyzing",0

	StateCRCok		DB "CRC check OK",0
	StateCRCerr		DB "CRC check failed",0

	RequestStr1		DB "unknown request",0
	RequestStr2		DB "ready to process next volume ",0
	RequestStr3		DB "overwrite existing file ",0
	RequestStr4		DB "using ""testpassword"" as password for encrypted file ",0
	RequestStr5		DB "continue? there are special attributes set for file ",0
		
	ConvStr0		DB "%X",0
	ConvStr1		DB "%s%s (%I64d byte uncompressed, %I64d byte compressed)",0
	ConvStr2		DB "  processed: %I64d of %I64d bytes (%I64d of %I64d bytes)",0
	
	WellDone		DB "Extraction finished quite well !",0

; #########################################################################

.CODE

start:

	invoke GetModuleHandle, NULL
	mov hInstance, eax

	invoke CallAceInitDll
	invoke FileExists, ADDR ArchiveName_
	.if eax == TRUE
		invoke ACEReadArchiveData, ADDR ArchiveName_, ADDR ArchiveData
		mov edx, OFFSET ArchiveData
		mov ebx, [edx+0]
		.if ebx == FALSE			;ArchiveData.ArchiveData
			invoke MessageBox,0,ADDR ErrorMsg1,ADDR caption, MB_OK+MB_ICONSTOP
			jmp the_end
		.endif
	.else
		invoke MessageBox,0,ADDR ErrorMsg2,ADDR caption, MB_OK+MB_ICONSTOP
		jmp the_end
	.endif
	
	invoke DialogBoxParam,hInstance, 100,0,ADDR WndProc,0

the_end:
	invoke ExitProcess, 0


; #########################################################################

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, LParam:DWORD

      .if uMsg == WM_INITDIALOG
		invoke LoadIcon,hInstance,500
        mov hIcon, eax
        invoke SendMessage,hWin,WM_SETICON,1,hIcon
		invoke SendMessage,hWin,WM_SETTEXT,0,ADDR caption
		push hWin
		pop hWindow
		invoke SendDlgItemMessage, hWin, 305, WM_SETTEXT,0, ADDR ArchiveName_
		invoke SendDlgItemMessage,hWin,3000,WM_SETTEXT,0, ADDR DestinationDir_

      .elseif uMsg == WM_COMMAND
		.if wParam == IDOK
			;EXTRACT WITH FULL PATH
			invoke GetDlgItemText,hWin,3000,ADDR DestinationDir_,260
			invoke CallACEExtract, ADDR ArchiveName_, ADDR DestinationDir_, 0
			mov Result_, eax

			;EXTRACT 2 current dir
			;invoke CallACEExtract, ADDR ArchiveName_, ADDR DestinationDir_, 1
			;mov Result_, eax
	
			;LIST
			;invoke CallACEList, ADDR ArchiveName_
			;mov Result_, eax

			;TEST
			;invoke CallACETest, ADDR ArchiveName_
			;mov Result_, eax
			.if eax == 0
				;printf("\nActiveACE operation return code: %d\n", Result) == 0
				invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR NStr
				invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR WellDone
				invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
			.else
				invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR NStr
				invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR ErrorMsg0
				invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
			.endif
		.elseif wParam == IDCANCEL
			invoke EndDialog,hWin,0
		.endif

	  .elseif uMsg == WM_CLOSE
			invoke EndDialog,hWin,0
      .endif

    xor eax, eax
    ret

WndProc endp

; #########################################################################

;*-----------------HandleStateStartArchive-------------------------------*

HandleStateStartArchive PROC Archive_:pACECallbackArchiveStruc

	LOCAL	ActionStr	:LPSTR

	mov edx,Archive_
	mov ebx, [edx+8]
	.if ebx == ACE_CALLBACK_OPERATION_LIST	;Archive_.Operation
		push OFFSET ActionStr1
		pop ActionStr
		;ActionStr = "Listing ";
	.elseif ebx == ACE_CALLBACK_OPERATION_TEST
		push OFFSET ActionStr2
		pop ActionStr
		;ActionStr = "Testing ";
	.elseif ebx == ACE_CALLBACK_OPERATION_EXTRACT
		push OFFSET ActionStr3
		pop ActionStr
		;ActionStr = "Extracting ";
	.else
		push OFFSET ActionStr4
		pop ActionStr
		;ActionStr = "unknown operation on ";
	.endif
	invoke RtlFillMemory, Addr TextBuf,256,0
	invoke lstrcpy, ADDR TextBuf, ActionStr
	mov edx,Archive_
	mov edx,[edx+16]			;Archive->ArchiveData->ArchiveName
	mov edx,[edx]
	invoke lstrcat, ADDR TextBuf, edx
	invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR TextBuf
	invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
  mov eax, ACE_CALLBACK_RETURN_OK
  ret

HandleStateStartArchive ENDP

;*-----------------HandleStateStartFile----------------------------------*

HandleStateStartFile PROC ArchivedFile:pACECallbackArchivedFileStruc
	
	LOCAL	ActionStr	:LPSTR

	mov edx, ArchivedFile
	mov ebx, [edx+8]
	.if ebx == ACE_CALLBACK_OPERATION_LIST	;ArchivedFile.Operation 
		push OFFSET ActionStr5
		pop ActionStr
		;ActionStr = "Found";
	.elseif ebx == ACE_CALLBACK_OPERATION_TEST
		push OFFSET ActionStr2
		pop ActionStr
		;ActionStr = "Testing";
	.elseif ebx == ACE_CALLBACK_OPERATION_ANALYZE
		push OFFSET ActionStr5
		pop ActionStr
		;ActionStr = "Analyzing";
	.elseif ebx == ACE_CALLBACK_OPERATION_EXTRACT
		push OFFSET ActionStr3
		pop ActionStr
		;ActionStr = "Extracting";
	.else
		push OFFSET ActionStr4
		pop ActionStr
		;ActionStr = "unknown operation on";
	.endif
	invoke RtlFillMemory, Addr TextBuf,256,0		;clear buffer
	mov edx, ArchivedFile
	add edx, 20										;ArchivedFile->FileData->SourceFileName
	;ArchivedFile->FileData->Size
	mov edx,[edx]
	push [edx+32]									;push 1st 4 bytes of qword
	push [edx+36]									;push 2nd 4 bytes of qword

	pop Dummy32_1
	pop Dummy32_2
	finit					;initialise FPU
	fild Dummy32_1			;load 1st dword on TOS
	fild Dummy32_2			;load 2nd dword on TOS
	fadd					;ST(0)+ST(1)
	fistp Dummy64_1			;pop Dummy64
	;ArchivedFile->FileData->CompressedSize
	push [edx+24]
	push [edx+28]
	pop Dummy32_1
	pop Dummy32_2
	fild Dummy32_1			;load 1st dword on TOS
	fild Dummy32_2			;load 2nd dword on TOS
	fadd					;ST(0)+ST(1)
	fistp Dummy64_2			;pop Dummy64
	
	mov ebx, [edx]	
	invoke wsprintf, ADDR TextBuf, ADDR ConvStr1, ActionStr,ebx,Dummy64_1,Dummy64_2
	invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR TextBuf
	invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0

	mov eax, ACE_CALLBACK_RETURN_OK
	ret

HandleStateStartFile ENDP

;*-----------------HandleErrorGlobal-------------------------------------*

HandleErrorGlobal PROC Error:pACECallbackGlobalStruc

	LOCAL	ErrorStr:LPSTR
	LOCAL	Result	:DWORD

	mov Result, ACE_CALLBACK_RETURN_OK

	mov edx, Error
	mov ebx, [edx+4]
	.if ebx == ACE_CALLBACK_ERROR_MEMORY	;Error.Code
		push OFFSET ErrorStr1
		pop ErrorStr						;not enough memory
	.elseif ebx == ACE_CALLBACK_ERROR_UNCSPACE
		push OFFSET ErrorStr2
		pop ErrorStr						;could not detect available space on network drive
	.else
		push OFFSET ErrorStr3
		pop ErrorStr						;unknown
		mov Result, ACE_CALLBACK_RETURN_CANCEL
	.endif

	invoke lstrcpy,ADDR TextBuf,ADDR ErrorStr0
	invoke lstrcat,ADDR TextBuf,ErrorStr
	invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR TextBuf
	invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0

	mov eax, Result
	ret

HandleErrorGlobal ENDP

;*-----------------HandleErrorArchive------------------------------------*

HandleErrorArchive PROC Error:pACECallbackArchiveStruc

	LOCAL ErrorStr	:LPSTR
	LOCAL Result	:DWORD
	LOCAL DoPrompt	:BOOL
	
	mov Result, ACE_CALLBACK_RETURN_OK
	mov DoPrompt, 0

	mov edx, Error
	mov ebx, [edx+4]
	.if ebx == ACE_CALLBACK_ERROR_AV		;Error.Code
		push OFFSET ErrorStr4
		pop ErrorStr		;AV of archive %s invalid
	.elseif ebx == ACE_CALLBACK_ERROR_OPENARCHIVEREAD
		push OFFSET ErrorStr5
		pop ErrorStr		;could not open archive %s for reading
	.elseif ebx == ACE_CALLBACK_ERROR_READARCHIVE
		push OFFSET ErrorStr6
		pop ErrorStr		;error reading from archive %s
	.elseif ebx == ACE_CALLBACK_ERROR_ARCHIVEBROKEN
		push OFFSET ErrorStr7
		pop ErrorStr		;archive %s is broken
	.elseif edx == ACE_CALLBACK_ERROR_NOFILES
		push OFFSET ErrorStr8
		pop ErrorStr		;no files specified
	.elseif ebx == ACE_CALLBACK_ERROR_ISNOTANARCHIVE
		push OFFSET ErrorStr9
		pop ErrorStr		;file is not an ACE archive
	.elseif ebx == ACE_CALLBACK_ERROR_HIGHERVERSION
		push OFFSET ErrorStr10
		pop ErrorStr		;this Dll version is not able to handle the archive
	.else
		push OFFSET ErrorStr3
		pop ErrorStr		;unknown
		mov Result, ACE_CALLBACK_RETURN_CANCEL
	.endif

;	.if DoPrompt == TRUE
	    ;invoke UserPrompt, ErrorStr, Error->ArchiveData->ArchiveName, 0
;   .else
		invoke lstrcpy,ADDR TextBuf,ADDR ErrorStr0
		invoke lstrcat,ADDR TextBuf,ErrorStr
		mov edx, Error
		mov edx, [edx+16]		;Error->ArchiveData->ArchiveName
		mov edx, [edx]
		invoke lstrcat,ADDR TextBuf,edx
		invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR TextBuf
		invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
;	.endif

	mov eax, Result
	ret

HandleErrorArchive ENDP

;*-----------------HandleErrorArchivedFile-------------------------------*

HandleErrorArchivedFile PROC Error:pACECallbackArchivedFileStruc

	LOCAL	ErrorStr	:LPSTR
	LOCAL	Result		:DWORD

	mov Result, ACE_CALLBACK_RETURN_OK
	
	mov edx, Error
	mov ebx, [edx+4]
	.if ebx == ACE_CALLBACK_ERROR_CREATIONNAMEINUSE
		push OFFSET ErrorStr11
		pop ErrorStr				;could not extract %s: name used by directory
	.elseif ebx == ACE_CALLBACK_ERROR_WRITE
		push OFFSET ErrorStr12
		pop ErrorStr				;error writing %s
	.elseif ebx == ACE_CALLBACK_ERROR_OPENWRITE
		push OFFSET ErrorStr13
		pop ErrorStr				;error opening %s for writing
	.elseif ebx == ACE_CALLBACK_ERROR_METHOD
		push OFFSET ErrorStr14
		pop ErrorStr				;compression method not known to this Dll version
	.elseif ebx == ACE_CALLBACK_ERROR_EXTRACTSPACE
		push OFFSET ErrorStr15
		pop ErrorStr				;not enough space to extract %s
	.elseif ebx == ACE_CALLBACK_ERROR_CREATION
		push OFFSET ErrorStr16
		pop ErrorStr				;creation of %s failed (write-protection?)
	.else
		push OFFSET ErrorStr3
		pop ErrorStr				;unknown
		mov Result, ACE_CALLBACK_RETURN_CANCEL
	.endif

	invoke lstrcpy,ADDR TextBuf,ADDR ErrorStr0
	invoke lstrcat,ADDR TextBuf,ErrorStr
	mov edx, Error
	mov edx, [edx+20]				;Error->FileData->SourceFileName
	mov edx, [edx]
	invoke lstrcat,ADDR TextBuf,edx
	invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR TextBuf
	invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0

	mov eax, Result
	ret

HandleErrorArchivedFile ENDP

;*-----------------HandleErrorRealFile-----------------------------------*

HandleErrorRealFile PROC Error:pACECallbackRealFileStruc

	LOCAL	ErrorStr	:LPSTR
	LOCAL	Result		:DWORD

	mov Result, ACE_CALLBACK_RETURN_OK

;	mov edx, Error	
;	.if [edx+4] ==
;	.else
		push OFFSET ErrorStr3	;unknown
		pop ErrorStr
		mov Result, ACE_CALLBACK_RETURN_CANCEL
;	.endif

	invoke lstrcpy,ADDR TextBuf,ADDR ErrorStr0
	invoke lstrcat,ADDR TextBuf,ErrorStr
	mov edx, Error
	mov edx, [edx+20]				;Error->FileName
	invoke lstrcat,ADDR TextBuf,edx
	invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR TextBuf
	invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0

	mov eax, Result
	ret

HandleErrorRealFile ENDP

;*-----------------HandleErrorSpace--------------------------------------*

HandleErrorSpace PROC Error:pACECallbackSpaceStruc

	LOCAL	ErrorStr	:LPSTR
	LOCAL	Result		:DWORD

	;ErrorStr = "";
	mov Result, ACE_CALLBACK_RETURN_OK

;	mov edx, Error
;	.if [edx+4] ==
;	.else
		push OFFSET ErrorStr3	;unknown
		pop ErrorStr
		mov Result, ACE_CALLBACK_RETURN_CANCEL
;	.endif

	invoke lstrcpy,ADDR TextBuf,ADDR ErrorStr0
	invoke lstrcat,ADDR TextBuf,ErrorStr
	mov edx, Error
	mov edx, [edx+20]				;Error->Directory
	invoke lstrcat,ADDR TextBuf,edx
	invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR TextBuf
	invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0

	mov eax, Result
	ret

HandleErrorSpace ENDP

;*-----------------HandleErrorSFXFile------------------------------------*

HandleErrorSFXFile	PROC Error:pACECallbackSFXFileStruc

	LOCAL	ErrorStr	:LPSTR
	LOCAL	Result		:DWORD

	;ErrorStr = "";
	mov Result, ACE_CALLBACK_RETURN_OK

;	mov edx, Error
;	.if [edx+4] ==
;	.else
		push OFFSET ErrorStr3	;unknown
		pop ErrorStr
		mov Result, ACE_CALLBACK_RETURN_CANCEL
;	.endif

	invoke lstrcpy,ADDR TextBuf,ADDR ErrorStr0
	invoke lstrcat,ADDR TextBuf,ErrorStr
	mov edx, Error
	mov edx, [edx+20]				;Error->SFXFileName
	invoke lstrcat,ADDR TextBuf,edx
	invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR TextBuf
	invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0

	mov eax, Result
	ret

HandleErrorSFXFile ENDP

;*-----------------HandleRequestGlobal-----------------------------------*

HandleRequestGlobal PROC Request:pACECallbackGlobalStruc

	LOCAL	RequestStr	:LPSTR

	;RequestStr = "";
	
	;mov edx, Request
	;.if [edx+4] ==
	;.else
		invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,RequestStr1
		invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
		;"\nunknown request\n"
	;	return ACE_CALLBACK_RETURN_CANCEL;
	;.endif
	mov eax, ACE_CALLBACK_RETURN_CANCEL
	ret

HandleRequestGlobal ENDP

;*-----------------HandleRequestArchive----------------------------------*

HandleRequestArchive PROC Request:pACECallbackArchiveStruc

	LOCAL	RequestStr:LPSTR

	push OFFSET NStr
	pop RequestStr
	
	mov edx, Request
	mov ebx, [edx+4]
	.if ebx == ACE_CALLBACK_REQUEST_CHANGEVOLUME	;Request.Code
		push OFFSET RequestStr2
		pop RequestStr			;RequestStr = "ready to process next volume %s";
	.else
		invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,RequestStr1
		invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
		;"unknown request"
		mov eax, ACE_CALLBACK_RETURN_CANCEL
		ret
	.endif
	mov edx, [edx+16]		;Request->ArchiveData->ArchiveName
	mov edx, [edx]
	invoke UserPrompt, RequestStr, edx, 1		
	ret

HandleRequestArchive ENDP

;*-----------------HandleRequestArchivedFile-----------------------------*

HandleRequestArchivedFile PROC Request:pACECallbackArchivedFileStruc
	
	LOCAL	RequestStr:LPSTR

	push OFFSET NStr
	pop RequestStr

	mov edx, Request
	mov ebx, [edx+4]
	.if ebx == ACE_CALLBACK_REQUEST_OVERWRITE		;Request->Code
		push OFFSET RequestStr3
		pop RequestStr						;"overwrite existing file %s"
	.elseif ebx == ACE_CALLBACK_REQUEST_OVERWRITESYSFILE
		push OFFSET RequestStr5
		pop RequestStr						;"overwrite existing file %s"
	.elseif ebx ==  ACE_CALLBACK_REQUEST_PASSWORD
		push OFFSET RequestStr4
		pop RequestStr						;"%s is encrypted, using "testpassword" as password"
;;		push OFFSET TestPWD
;;		pop ...;Request->GlobalData->DecryptPassword = "testpassword";
	.else
		invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,RequestStr1
		invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
		;"unknown request"
		mov eax, ACE_CALLBACK_RETURN_CANCEL
		ret
	.endif
	mov edx, [edx+20]			;Request->FileData->SourceFileName
	mov edx, [edx]
	invoke UserPrompt, RequestStr, edx, 1
	ret
	
HandleRequestArchivedFile ENDP

;*-----------------HandleRequestRealFile---------------------------------*

HandleRequestRealFile PROC Request:pACECallbackRealFileStruc

	LOCAL	RequestStr	:LPSTR

	;RequestStr = "";
	;mov edx, Request	
	;.if [edx+4] ==			;Request->Code
	;.else
		;printf("\nunknown request\n");
		invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,RequestStr1
		invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
		mov eax, ACE_CALLBACK_RETURN_CANCEL
		ret
	;.endif
;	invoke UserPrompt, RequestStr, Request->FileName, 1
;	ret

HandleRequestRealFile ENDP

;*-----------------InfoProc callback-------------------------------------*

InfoProc PROC  Info:pACEInfoCallbackProcStruc

	LOCAL	InfoStr	:LPSTR

	mov edx, Info
	mov ebx, [edx+4]
	.if ebx == ACE_CALLBACK_INFO_FILELISTCREATE	;Info.Global_.Code
		push OFFSET InfoStr1		;creating file list
		pop InfoStr
	.elseif ebx == ACE_CALLBACK_INFO_FILELISTCREATEEND
		push OFFSET InfoStr2		;finished creating file list
		pop InfoStr			
	.elseif ebx == ACE_CALLBACK_INFO_FILELISTADD
		push OFFSET InfoStr3		;adding file to file list
		pop InfoStr
	.else
		push OFFSET NStr			;InfoStr = ""
		pop InfoStr
	.endif

	invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,InfoStr
	invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0

	mov eax, ACE_CALLBACK_RETURN_OK
	ret

InfoProc ENDP

;*-----------------ErrorProc callback------------------------------------*

ErrorProc PROC  Error:pACEErrorCallbackProcStruc

	mov edx, Error
	mov ebx, [edx+0]
	.if ebx == ACE_CALLBACK_TYPE_GLOBAL		;Error->StructureType
		invoke HandleErrorGlobal, edx			;ADDR Error->Global_
		ret
	.elseif ebx == ACE_CALLBACK_TYPE_ARCHIVE
		invoke HandleErrorArchive, edx			;ADDR Error->Archive_
		ret
	.elseif ebx == ACE_CALLBACK_TYPE_ARCHIVEDFILE
		invoke HandleErrorArchivedFile, edx		;ADDR Error->ArchivedFile
		ret
	.elseif ebx == ACE_CALLBACK_TYPE_REALFILE
		invoke HandleErrorRealFile, edx			;ADDR Error->RealFile
		ret
	.elseif ebx == ACE_CALLBACK_TYPE_SPACE
		invoke HandleErrorSpace, edx			;ADDR Error->Space
		ret
	.elseif ebx == ACE_CALLBACK_TYPE_SFXFILE
		invoke HandleErrorSFXFile, edx			;ADDR Error->SFXFile
		ret
	.else
		mov eax, ACE_CALLBACK_RETURN_CANCEL
		ret
	.endif

ErrorProc ENDP

;*-----------------RequestProc callback----------------------------------*

RequestProc PROC  Request:pACERequestCallbackProcStruc
	
	mov edx, Request
	mov ebx, [edx+0]
	.if ebx == ACE_CALLBACK_TYPE_GLOBAL		;Request->StructureType
		invoke HandleRequestGlobal, edx			;ADDR Request->Global
		ret
	.elseif ebx == ACE_CALLBACK_TYPE_ARCHIVE
		invoke HandleRequestArchive, edx		;ADDR Request->Archive
		ret
	.elseif ebx == ACE_CALLBACK_TYPE_ARCHIVEDFILE
		invoke HandleRequestArchivedFile, edx	;ADDR Request->ArchivedFile
		ret
	.elseif ebx == ACE_CALLBACK_TYPE_REALFILE
		invoke HandleRequestRealFile, edx		;ADDR Request->RealFile
		ret
	.else
		mov eax, ACE_CALLBACK_RETURN_CANCEL
		ret
	.endif
 
RequestProc ENDP

;*-----------------StateProc callback------------------------------------*

StateProc PROC  State:pACEStateCallbackProcStruc

	mov edx, State
	mov ebx, [edx+0]
	.if ebx == ACE_CALLBACK_TYPE_ARCHIVE			;State->StructureType
		mov ebx, [edx+4]
		.if ebx == ACE_CALLBACK_STATE_STARTARCHIVE	;State->Archive_.Code
			invoke HandleStateStartArchive,	edx			;ADDR State->Archive_
			ret
		.endif
	.elseif ebx == ACE_CALLBACK_TYPE_ARCHIVEDFILE	;State->StructureType
		mov ebx, [edx+4]
		.if ebx == ACE_CALLBACK_STATE_STARTFILE		;State->ArchivedFile.Code
			invoke HandleStateStartFile, edx			;ADDR State->ArchivedFile
			ret
		.elseif ebx == ACE_CALLBACK_STATE_ENDNOCRCCHECK	;State->ArchivedFile.Code
		.endif
	.elseif ebx == ACE_CALLBACK_TYPE_PROGRESS
		mov ebx, [edx+4]
		.if ebx == ACE_CALLBACK_STATE_PROGRESS		;State->Progress.Code
			mov ebx, [edx+24]
			;State->Progress.ProgressData->FileProcessedSize
			push [ebx+32]			;push 1st 4 bytes of qword
			push [ebx+36]			;push 2nd 4 bytes of qword
			pop Dummy32_1
			pop Dummy32_2
			finit					;initialise FPU
			fild Dummy32_1			;load 1st dword on TOS
			fild Dummy32_2			;load 2nd dword on TOS
			fadd					;ST(0)+ST(1)
			fistp Dummy64_1			;pop Dummy64
			;State->Progress.ProgressData->FileSize
			push [ebx+48]			
			push [ebx+52]			
			pop Dummy32_1
			pop Dummy32_2
			fild Dummy32_1
			fild Dummy32_2
			fadd					
			fistp Dummy64_2			
			;State->Progress.ProgressData->TotalProcessedSize
			push [ebx+8]	 		
			push [ebx+12]			
			pop Dummy32_1
			pop Dummy32_2
			fild Dummy32_1
			fild Dummy32_2
			fadd					
			fistp Dummy64_3			
			;State->Progress.ProgressData->TotalSize)
			push [ebx+24]			
			push [ebx+28]			
			pop Dummy32_1
			pop Dummy32_2
			fild Dummy32_1
			fild Dummy32_2
			fadd					
			fistp Dummy64_4			
			invoke wsprintf,ADDR TextBuf,ADDR ConvStr2, Dummy64_1,Dummy64_2,Dummy64_3,Dummy64_4
			invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR TextBuf
			invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
		.endif
	.elseif ebx == ACE_CALLBACK_TYPE_CRCCHECK		;State->StructureType
		mov ebx, [edx+4]
		.if ebx == ACE_CALLBACK_STATE_ENDCRCCHECK	;State->CRCCheck.Code
			mov ebx, [edx+24]			;State->CRCCheck.CRCOk
			.if ebx == TRUE
				invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR StateCRCok
				invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
			.else
				invoke SendDlgItemMessage,hWindow,101,LB_INSERTSTRING,-1,ADDR StateCRCerr
				invoke SendDlgItemMessage,hWindow,101,LB_SETTOPINDEX,eax,0
			.endif
		.endif
	.endif

	mov eax, ACE_CALLBACK_RETURN_OK
	ret

StateProc ENDP

;*-----------------UserPrompt--------------------------------------------*

UserPrompt PROC PromptStr:LPSTR, Param:LPSTR, IsRequest:BOOL

	invoke lstrcpy,ADDR TextBuf,PromptStr
	invoke lstrcat,ADDR TextBuf,Param 
	invoke MessageBox,hWindow,ADDR TextBuf,ADDR caption,MB_YESNOCANCEL
	.if eax == IDYES
		mov eax, ACE_CALLBACK_RETURN_OK
		ret
	.elseif eax == IDNO
		mov eax, ACE_CALLBACK_RETURN_NO
		ret
	.endif

	mov eax, ACE_CALLBACK_RETURN_CANCEL
	ret

UserPrompt ENDP

;*-----------------CallAceInitDll----------------------------------------*

CallAceInitDll PROC

	;memset(&DllData, 0, sizeof(DllData));   ; set all fields to zero

	mov DllData.GlobalData.MaxArchiveTestBytes, 01FFFFh	; search for archive
								; header in first 128k of file
	mov DllData.GlobalData.MaxFileBufSize, 02FFFFh
								; read/write buffer size is 256k
	mov DllData.GlobalData.Comment_.BufSize, SIZEOF CommentBuf
	push OFFSET CommentBuf
	pop DllData.GlobalData.Comment_.Buf
								; set comment bufffer to receive comments
								; of archive and/or set comments

	invoke GetTempPath, 255, ADDR TempPath
	mov eax, OFFSET TempPath
	mov DllData.GlobalData.TempDir, eax	; set temp dir

	; set callback function pointers
	mov DllData.GlobalData.InfoCallbackProc, InfoProc
	mov DllData.GlobalData.ErrorCallbackProc, ErrorProc
	mov DllData.GlobalData.RequestCallbackProc, RequestProc
	mov DllData.GlobalData.StateCallbackProc, StateProc

	invoke ACEInitDll, ADDR DllData

CallAceInitDll ENDP

;*-----------------FileExists--------------------------------------------*

FileExists PROC FileName:LPSTR

	LOCAL wfd:WIN32_FIND_DATA 

	invoke FindFirstFile, FileName, ADDR wfd
	.if eax == INVALID_HANDLE_VALUE
		xor eax,eax
	.else
		invoke lstrcpy, FileName, ADDR wfd.cFileName
		invoke FindClose, eax
		mov eax, 1
	.endif
	ret

FileExists ENDP

;*-----------------CallACEList-------------------------------------------*

CallACEList PROC ArchiveName :LPSTR
	
	LOCAL List:tACEListStruc

	;memset(&List, 0, sizeof(List));    ; set all fields to zero

	mov List.Files.SourceDir, OFFSET NStr			; archive main directory is
									    ; base directory for FileList
	push OFFSET FileList
	pop List.Files.FileList				; set FileList
	mov List.Files.ExcludeList, OFFSET NStr		; no files to exclude
	mov List.Files.FullMatch, 0			; also list files partially matching
                                        ; (for instance: list DIR1\TEST.DAT
                                        ;  if FileList specifies TEST.DAT)

	invoke ACEList, ArchiveName, ADDR List
	ret

CallACEList ENDP

;*-----------------CallACETest-------------------------------------------*

CallACETest PROC ArchiveName:LPSTR
	
	LOCAL Test_:tACETestStruc
	
	;memset(&Test, 0, sizeof(Test))     ; set all fields to zero
	mov Test_.Files.SourceDir, OFFSET NStr       ; archive main directory is
										; base directory for FileList
	push OFFSET FileList
	pop Test_.Files.FileList			; set FileList
	mov Test_.Files.ExcludeList, OFFSET NStr      ; no files to exclude
	mov Test_.Files.FullMatch, 0        ; also test files partially matching

	mov Test_.DecryptPassword, OFFSET NStr         ; no encrypted file expected

	invoke ACETest, ArchiveName, ADDR Test_
	ret

CallACETest ENDP

;*-----------------CallACEExtract----------------------------------------*

CallACEExtract PROC ArchiveName:LPSTR, DestinationDir:LPSTR, DoExcludePath:BOOL
	
	LOCAL Extract:tACEExtractStruc

	;memset(&Extract, 0, sizeof(Extract));          ; set all fields to zero

	mov Extract.Files.SourceDir, OFFSET NStr     ; archive main directory is
                                                 ; base dir for FileList
	push OFFSET FileList
	pop Extract.Files.FileList			         ; set FileList
	mov Extract.Files.ExcludeList, OFFSET NStr   ; no files to exclude
	mov Extract.Files.FullMatch, 0               ; also extract files
                                                 ; partially matching
	mov eax, DestinationDir
	mov Extract.DestinationDir, eax				 ; directory to extract to
	mov eax, DoExcludePath       
	mov Extract.ExcludePath, eax				 ; extract files with path?
	mov Extract.DecryptPassword, OFFSET NStr     ; no encrypted file expected

	invoke ACEExtract, ArchiveName, ADDR Extract
	ret

CallACEExtract ENDP

;*-----------------End---------------------------------------------------*

end start